﻿using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Controls.Primitives;
using Microsoft.UI.Xaml.Data;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media;
using Microsoft.UI.Xaml.Navigation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;

// To learn more about WinUI, the WinUI project structure,
// and more about our project templates, see: http://aka.ms/winui-project-info.

namespace CH12_ResponsiveWinUI3
{
    /// <summary>
    /// An empty window that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainWindow : Window, INotifyPropertyChanged
    {
        private DispatcherTimer _dispatcherTimer;
        private bool _isWorking;
        public event PropertyChangedEventHandler PropertyChanged;

        public MainWindow()
        {
            this.InitializeComponent();
            _dispatcherTimer = new DispatcherTimer();
            _dispatcherTimer.Interval = TimeSpan.FromSeconds(10);
            _dispatcherTimer.Tick += DispatcherTimer_Tick;
        }

        private void DispatcherTimer_Tick(object sender, object e)
        {
            _dispatcherTimer?.Stop();
            _dispatcherTimer.Tick -= DispatcherTimer_Tick;
            IsWorking = false;
            MessageTextBlock.Text = "Work completed";
        }

        private void NotifyPropertyChanged(string property)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(property));
        }

        public bool IsWorking { 
            get { return _isWorking; } 
            set
            {
                _isWorking = value;
                NotifyPropertyChanged("IsWorking");
            }
        }

        private void DoWorkButton_Click(object sender, RoutedEventArgs e)
        {
            DoWorkButton.Visibility = Visibility.Collapsed;
            IsWorking = true;
            _dispatcherTimer.Start();
        }
    }
}
